# This file was auto-generated by Fern from our API Definition.

import typing

import httpx

from .core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .resources.actions.client import ActionsClient, AsyncActionsClient
from .resources.agents.client import AgentsClient, AsyncAgentsClient
from .resources.calls.client import AsyncCallsClient, CallsClient
from .resources.numbers.client import AsyncNumbersClient, NumbersClient
from .resources.usage.client import AsyncUsageClient, UsageClient
from .resources.voices.client import AsyncVoicesClient, VoicesClient
from .resources.webhooks.client import AsyncWebhooksClient, WebhooksClient


class Vocode:
    def __init__(
        self,
        *,
        environment: str,
        token: typing.Union[str, typing.Callable[[], str]],
        timeout: typing.Optional[float] = 60
    ):
        self._environment = environment
        self._client_wrapper = SyncClientWrapper(token=token, httpx_client=httpx.Client(timeout=timeout))
        self.numbers = NumbersClient(environment=environment, client_wrapper=self._client_wrapper)
        self.calls = CallsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.usage = UsageClient(environment=environment, client_wrapper=self._client_wrapper)
        self.actions = ActionsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.agents = AgentsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.voices = VoicesClient(environment=environment, client_wrapper=self._client_wrapper)
        self.webhooks = WebhooksClient(environment=environment, client_wrapper=self._client_wrapper)


class AsyncVocode:
    def __init__(
        self,
        *,
        environment: str,
        token: typing.Union[str, typing.Callable[[], str]],
        timeout: typing.Optional[float] = 60
    ):
        self._environment = environment
        self._client_wrapper = AsyncClientWrapper(token=token, httpx_client=httpx.AsyncClient(timeout=timeout))
        self.numbers = AsyncNumbersClient(environment=environment, client_wrapper=self._client_wrapper)
        self.calls = AsyncCallsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.usage = AsyncUsageClient(environment=environment, client_wrapper=self._client_wrapper)
        self.actions = AsyncActionsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.agents = AsyncAgentsClient(environment=environment, client_wrapper=self._client_wrapper)
        self.voices = AsyncVoicesClient(environment=environment, client_wrapper=self._client_wrapper)
        self.webhooks = AsyncWebhooksClient(environment=environment, client_wrapper=self._client_wrapper)
